#!/usr/bin/env python

import xml.parsers.expat

class MenuConfig:
  def __init__(self, menu_path):
    self.menu_path = menu_path
    self.xml_parser = xml.parsers.expat.ParserCreate()
    self.tmp_menu_label = self.tmp_menu_extra_opts = self.menu_background_path =\
    self.rus_font_path = self.product_name = self.welcome_message = ""
    self.menu_lst = []
    self.parse()
 
  def _start_element(self, name, attrs):
    if name == "item":
      self.tmp_menu_label = attrs["name"]
      self.xml_parser.CharacterDataHandler = self._char_data_item
    elif name == "background_img_path":
      self.xml_parser.CharacterDataHandler = self._char_data_image_path
    elif name == "font_path":
      self.xml_parser.CharacterDataHandler = self._char_data_rus_font_path
    elif name == "product_name":
      self.xml_parser.CharacterDataHandler = self._char_data_product_name
    elif name == "welcome_message":
      self.xml_parser.CharacterDataHandler = self._char_data_welcome_message
      

  def _end_element(self, name):
    if name == "item":
      self.menu_lst.append((self.tmp_menu_label , self.tmp_menu_extra_opts))
      self.tmp_menu_extra_opts = ""
      self.tmp_menu_label = ""

  def _char_data_item(self, data):
    data = data.strip()
    if (data != ''):
      self.tmp_menu_extra_opts += (" " + data)

  def _char_data_image_path(self, data):
    data = data.strip()
    if (data != ''):
      self.menu_background_path = data

  def _char_data_rus_font_path(self, data):
    data = data.strip()
    if (data != ''):
      self.rus_font_path = data

  def _char_data_product_name(self, data):
    data = data.strip()
    if (data != ''):
      self.product_name = data

  def _char_data_welcome_message(self, data):
    data = data.strip()
    if (data != ''):
      self.welcome_message = data

  def parse(self):
    self.xml_parser.StartElementHandler = self._start_element
    self.xml_parser.EndElementHandler = self._end_element
    self.xml_parser.ParseFile(open(self.menu_path))


if __name__ == "__main__":
  menu_parser = MenuConfig("menu_config.xml")
  print menu_parser.menu_lst
  print menu_parser.menu_background_path
